//+------------------------------------------------------------------+
//|                                                 MT_breakout.mq4  |
//|                                                        motochan  |
//|                                   http://1969681.blog66.fc2.com/ |
//+------------------------------------------------------------------+
#property copyright "motochan"
#property link      "http://1969681.blog66.fc2.com/"

#property indicator_chart_window

#property indicator_buffers 8
#property indicator_color1 SteelBlue
#property indicator_color2 Salmon
#property indicator_color3 SteelBlue
#property indicator_color4 Salmon
#property indicator_color7 Blue
#property indicator_color8 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//---- input parameters
extern int nPeriod=20;
extern int nLine=20;
extern int MA_Method=1;
extern int Apply=0;
extern int Limit=3000;

//---- indicator buffers
double buf1[1000]; //Sign-continuous buy
double buf2[1000]; //Sign-continuous sell
double buf3[1000]; //Sign-independence buy
double buf4[1000]; //Sign-independence sell

double Kairi_buffer[1000];
double Stdev_buffer[1000]; 
double tan_sum[1000];
double u_price[1000];
double l_price[1000];

double BarWidth = 0.1;
double margin = 0.02;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- Output in Char
    for(int i=0;i<nLine;i++)
    {
        ObjectCreate("MT_line_U"+i,OBJ_TREND,0,0,0,0,0);
        ObjectSet("MT_line_U"+i,OBJPROP_COLOR,Blue);
        ObjectSet("MT_line_U"+i,OBJPROP_WIDTH,1);
        ObjectSet("MT_line_U"+i,OBJPROP_RAY,true);
        
        ObjectCreate("MT_line_L"+i,OBJ_TREND,0,0,0,0,0);
        ObjectSet("MT_line_L"+i,OBJPROP_COLOR,Red);
        ObjectSet("MT_line_L"+i,OBJPROP_WIDTH,1);
        ObjectSet("MT_line_L"+i,OBJPROP_RAY,true);
    }
   
   //---- indicator buffers mapping

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexStyle(7,DRAW_ARROW);
   
   SetIndexArrow(0,233);
   SetIndexArrow(1,234);
   SetIndexArrow(2,233);
   SetIndexArrow(3,234);
   SetIndexArrow(6,159);
   SetIndexArrow(7,159);

   SetIndexBuffer(0,buf1);
   SetIndexBuffer(1,buf2);
   SetIndexBuffer(2,buf3);
   SetIndexBuffer(3,buf4);
   SetIndexBuffer(4,Kairi_buffer);
   SetIndexBuffer(5,Stdev_buffer);
   SetIndexBuffer(6,u_price);
   SetIndexBuffer(7,l_price);   

   SetIndexLabel(0,"buf1");
   SetIndexLabel(1,"buf2");
   SetIndexLabel(2,"buf3");
   SetIndexLabel(3,"buf4");
   SetIndexLabel(4,"Kairi_buffer");
   SetIndexLabel(5,"Stdev_buffer");
   SetIndexBuffer(6,"u_price");
   SetIndexBuffer(7,"l_price");  
   
   
         //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//---- TODO: add your code here
    int i;
    for(i=0;i<nLine;i++)
    {
        ObjectDelete("MT_line_U"+i);
        ObjectDelete("MT_line_L"+i);
            }
//----
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//---- TODO: add your code here
    int ii[];
    int j,i,ll;
    int a1[],b1[];
    double u_price1,l_price1;
    double u_price2,l_price2;
    double si1,si2;
    
    double aa,bb,cc;
    int al,bl;
         
    ArrayResize(ii,nLine*2+10);
    ArrayResize(a1,nLine*2+10);
    ArrayResize(b1,nLine*2+10);
             
    if(Bars<Limit) Limit=Bars-nPeriod;
           
    for(i=0; i<Limit; i++){
       Kairi_buffer[i] = iCustom(NULL,0,"Kairi",nPeriod,MA_Method,Apply,0,i);
       Stdev_buffer[i] = iStdDev(NULL,0,nPeriod,0,MA_Method,Apply,i);
   }
   
    j=0;   
    for(i=0; j<nLine*2+6; i++)
    {
      if (Kairi_buffer[i] * Kairi_buffer[i+1] <= 0){                   
         ii[j] = i;
         j++;
         }
    }
 
    if(Kairi_buffer[ii[0]]<0)
      {
      for(ll=0; ll<nLine+6;ll++)
         {
         a1[ll] = ArrayMaximum(Kairi_buffer, ii[1+ll*2]-ii[0+ll*2]+1, ii[0+ll*2]+1);
         b1[ll] = ArrayMinimum(Kairi_buffer, ii[2+ll*2]-ii[1+ll*2]+1, ii[1+ll*2]+1);
         }
      }
      else
      {
      for(ll=0; ll<nLine+6;ll++)
         {
       a1[ll] = ArrayMaximum(Kairi_buffer, ii[2+ll*2]-ii[1+ll*2], ii[1+ll*2]+1);
       b1[ll] = ArrayMinimum(Kairi_buffer, ii[1+ll*2]-ii[0+ll*2], ii[0+ll*2]+1);
         }
      }
    
    for(ll=0; ll<nLine;ll++)
    {    
      ObjectMove("MT_line_U"+ll,1,Time[a1[ll]],High[a1[ll]]);
      ObjectMove("MT_line_U"+ll,0,Time[a1[ll+1]],High[a1[ll+1]]);
      ObjectMove("MT_line_L"+ll,1,Time[b1[ll]],Low[b1[ll]]);
      ObjectMove("MT_line_L"+ll,0,Time[b1[ll+1]],Low[b1[ll+1]]);
    }

   al=0;
   bl=0;
   i=0;
   
for(i=0; i<Limit; i++){
      u_price[i]=EMPTY_VALUE;
      l_price[i]=EMPTY_VALUE;
      
      u_price[i]=ObjectGetValueByShift("MT_line_U"+al, i);   //BLUE LINE
      l_price[i]=ObjectGetValueByShift("MT_line_L"+bl, i);   //RED LINE

       if(i >= a1[al])   al=al+1;         
       if(i >= b1[bl])   bl=bl+1;
 }
 
 
for(i=0; i<Limit; i++){
       //tan_sum[i]=(MathArctan(u_price1 - u_price2) / BarWidth) * (180 / 3.14) + (MathArctan(l_price1 - l_price2) / BarWidth) * (180 / 3.14);     //CALCULATE TAN

      buf1[i]=EMPTY_VALUE;
      buf2[i]=EMPTY_VALUE;
      buf3[i]=EMPTY_VALUE;
      buf4[i]=EMPTY_VALUE;
            
      if(u_price[i] + margin<Close[i])  buf1[i] = u_price[i];
      else
      if(l_price[i] - margin>Close[i])  buf2[i] = l_price[i];
      }
      
 
//for(i=Limit; i>0; i--){

//      buf3[i]=EMPTY_VALUE;
//      buf4[i]=EMPTY_VALUE;
            
//      if(buf1[i+1]!=buf1[i])  buf3[i] = Close[i];
//      else
//      if(buf2[i+1]!=buf2[i])  buf4[i] = Close[i];
// }
 
 
        for(i=0;i<nLine;i++)
    {
        ObjectSet("MT_line_U"+i,OBJPROP_RAY,false);
        ObjectSet("MT_line_L"+i,OBJPROP_RAY,false);
    }
    
    
//----
   return(0);
}
//+------------------------------------------------------------------+


